(defsystem "aoc"
	   :long-name "Advent of Code"
	   :version "0.1.0"
	   :author "Peter Tillemans"
	   :maintainer "Peter Tillemans"
	   :mailto "pti@snamellit.com"
	   :license "MIT"
	   :homepage "https://forge.snamellit.com/pti/aoc-cl"
	   :bug-tracker "https://forge.snamellit.com/pti/aoc-cl/issues"
	   :source-control "https://forge.snamellit.com/pti/aoc-cl"
	   :depends-on (#:dexador
			#:cl-cookie
			#:plump
			#:lquery
			#:3d-vectors
			#:array-operations
			#:lla
			#:queues.simple-queue
			#:queues.priority-queue
			#:bt-semaphore ; threads higher level lib
			#:trivia                ; community standard pattern matching
			#:transducers
			#:smug
			#:fset
			#:arrow-macros 
			)
	   :components ((:module "src"
				 :components
				 ((:file "main")
				  (:file "maze")
				  (:file "2018/day06")
				  (:file "2018/day07")
				  (:file "2024/day01")
				  (:file "2024/day02")
				  (:file "2024/day03")
				  (:file "2024/day04")
				  (:file "2024/day05")
				  (:file "2024/day06")
				  (:file "2024/day07")
				  (:file "2024/day08")
				  (:file "2024/day09")
				  (:file "2024/day10")
				  (:file "2024/day11")
				  (:file "2024/day12")
				  (:file "2024/day13")
				  (:file "2024/day14")
				  (:file "2024/day15")
				  (:file "2024/day16")
				  (:file "2024/day17")
				  (:file "2024/day18")
				  (:file "2024/day19")
				  (:file "2024/day20")
				  (:file "2024/day21")
				  (:file "2024/day22")
				  (:file "2024/day23")
				  )))
	   :description "Advent of Code challenges and solutions."
	   :long-description "Solutions for the AOC challenges."
	   :in-order-to ((test-op (test-op "aoc/tests"))))

(defsystem "aoc/tests"
	   :author "Peter Tillemans"
	   :license "GPL"
	   :depends-on ("aoc"
			#:parachute)
	   :components ((:module "tests"
				 :components
				 ((:file "main")
				  (:file "2018/day06-test")
				  (:file "2018/day07-test")
				  (:file "2024/main")
				  (:file "2024/day01-test")
				  (:file "2024/day02-test")
				  (:file "2024/day03-test")
				  (:file "2024/day04-test")
				  (:file "2024/day05-test")
				  (:file "2024/day06-test")
				  (:file "2024/day07-test")
				  (:file "2024/day08-test")
				  (:file "2024/day09-test")
				  (:file "2024/day10-test")
				  (:file "2024/day11-test")
				  (:file "2024/day12-test")
				  (:file "2024/day13-test")
				  (:file "2024/day14-test")
				  (:file "2024/day15-test")
				  (:file "2024/day16-test")
				  (:file "2024/day17-test")
				  (:file "2024/day18-test")
				  (:file "2024/day19-test")
				  (:file "2024/day20-test")
				  (:file "2024/day21-test")
				  (:file "2024/day22-test")
				  (:file "2024/day23-test")
				  )))
	   :description "Test system for aoc"
	   :perform (test-op (op c) (symbol-call :parachute :test :aoc/tests)))
