(defpackage :aoc/2024/01
  (:use :cl :aoc :alexandria)
  (:export
   #:sample-data
   #:part1
   #:part2))

(in-package :aoc/2024/01)


(defun parse-line (s)
  (map 'list #'parse-integer (cl-ppcre:split "   " s)))

(defvar input-data '())
(setf input-data (map 'list #'parse-line (test-input 2024 1)))

(defvar sample-text "")
(setf sample-text (aoc:split-lines "3   4
4   3
2   5
1   3
3   9
3   3"))

(defvar sample-data '())
(setf sample-data (map 'list #'parse-line sample-text))

(defun difference (a b)
  (abs (- b a)))

(defun part1 (data)
  (reduce #'+
	  (mapcar #'difference
		  (sort (mapcar #'first data) #'<)
		  (sort (mapcar #'second data) #'<))))

(defun part2 (data)
  (let ((left (mapcar #'first data))
	(right (mapcar #'second data)))
    (loop for l in left
	  sum (* l (loop for r in right count (= l r))))))

(defun solve-day ()
  (format t "part1: ~A~%" (part1 input-data))
  (format t "part2: ~A~%" (part2 input-data)))
